Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 2624)
+++ .hgsubstate	(revision 2618)
@@ -1,1 +1,1 @@
-d80e4972aaaa26450e5d2f45d55ed8eca0706f9d inc/libs/clearbricks
+94b97f44f94e951b8b6392bd76d8c9a3791388e2 inc/libs/clearbricks
Index: Makefile
===================================================================
--- Makefile	(revision 2615)
+++ Makefile	(revision 2558)
@@ -40,8 +40,23 @@
 	./$(DC)/themes/
 
-	## Copy built-in plugins based on DC_DISTRIB_PLUGINS constant
-	cp -pRf $$(grep DC_DISTRIB_PLUGINS inc/prepend.php | \
-		sed -e "s/.*,'//" -e "s/'.*//" | \
-		sed -e  's/\(^\|,\)/ .\/plugins\//g') \
+	## Copy built-in plugins
+	cp -pRf \
+	./plugins/aboutConfig \
+	./plugins/akismet \
+	./plugins/antispam \
+	./plugins/attachments \
+	./plugins/blogroll \
+	./plugins/blowupConfig \
+	./plugins/dclegacy \
+	./plugins/fairTrackbacks \
+	./plugins/importExport \
+	./plugins/maintenance \
+	./plugins/tags \
+	./plugins/pages \
+	./plugins/pings \
+	./plugins/simpleMenu \
+	./plugins/themeEditor \
+	./plugins/userPref \
+	./plugins/widgets \
 	./$(DC)/plugins/
 
@@ -53,4 +68,5 @@
 	find $(DC)/admin/js/ie7/*.js -exec ./build-tools/min-js.php \{\} \;
 	find $(DC)/admin/js/jquery/*.js -exec ./build-tools/min-js.php \{\} \;
+	find $(DC)/admin/js/jsToolBar/*.js -exec ./build-tools/min-js.php \{\} \;
 	find $(DC)/admin/js/jsUpload/*.js -exec ./build-tools/min-js.php \{\} \;
 	find $(DC)/plugins -name '*.js' -exec ./build-tools/min-js.php \{\} \;
@@ -118,3 +134,2 @@
 
 
-copy-plugins: clean
Index: admin/_charte.php
===================================================================
--- admin/_charte.php	(revision 2504)
+++ admin/_charte.php	(revision 2501)
@@ -31,5 +31,4 @@
 	<script type="text/javascript" src="js/jquery/jquery.js"></script>
 	<script type="text/javascript" src="js/jquery/jquery-ui.custom.js"></script>
-	<script type="text/javascript" src="js/jquery/jquery.ui.touch-punch.js"></script>
 	<script type="text/javascript" src="js/jquery/jquery.pageTabs.js"></script>
 	<script type="text/javascript" src="js/jquery/jquery.biscuit.js"></script>
Index: admin/blog.php
===================================================================
--- admin/blog.php	(revision 2596)
+++ admin/blog.php	(revision 2566)
@@ -21,5 +21,5 @@
 
 # Create a blog
-if (!isset($_POST['id']) && (isset($_POST['create'])))
+if (!isset($_POST['id']) && !empty($_POST['blog_id']))
 {
 	$cur = $core->con->openCursor($core->prefix.'blog');
@@ -84,4 +84,9 @@
 	'<p class="form-note">'.__('At least 2 characters using letters, numbers or symbols.').'</p> ';
 
+	if ($blog_id) {
+		echo
+		'<p class="form-note warn">'.__('Please note that changing your blog ID may require changes in your public index.php file.').'</p>';
+	}
+
 	echo
 	'<p><label class="required" for="blog_name"><abbr title="'.__('Required field').'">*</abbr> '.__('Blog name:').'</label> '.
@@ -94,5 +99,5 @@
 	form::textarea('blog_desc',60,5,html::escapeHTML($blog_desc)).'</p>'.
 
-	'<p><input type="submit" accesskey="s" name="create" value="'.__('Create').'" /></p>'.
+	'<p><input type="submit" accesskey="s" value="'.__('Create').'" /></p>'.
 	'</form>';
 
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 2577)
+++ admin/blog_pref.php	(revision 2566)
@@ -166,7 +166,4 @@
 	$media_img_m_size = abs((integer) $_POST['media_img_m_size']);
 	if ($media_img_m_size < 0) { $media_img_m_size = 448; }
-
-	$nb_post_for_home = abs((integer) $_POST['nb_post_for_home']);
-	if ($nb_post_for_home <= 1) { $nb_post_for_home = 1; }
 
 	$nb_post_per_page = abs((integer) $_POST['nb_post_per_page']);
@@ -234,5 +231,4 @@
 		$blog_settings->system->put('note_title_tag',$_POST['note_title_tag']);
 
-		$blog_settings->system->put('nb_post_for_home',$nb_post_for_home);
 		$blog_settings->system->put('nb_post_per_page',$nb_post_per_page);
 		$blog_settings->system->put('use_smilies',!empty($_POST['use_smilies']));
@@ -516,8 +512,4 @@
 
 	'<div class="col">'.
-	'<p><label for="nb_post_for_home" class="classic">'.sprintf(__('Display %s entries on home page'),
-	form::field('nb_post_for_home',2,3,$blog_settings->system->nb_post_for_home)).
-	'</label></p>'.
-
 	'<p><label for="nb_post_per_page" class="classic">'.sprintf(__('Display %s entries per page'),
 	form::field('nb_post_per_page',2,3,$blog_settings->system->nb_post_per_page)).
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 2567)
+++ admin/categories.php	(revision 2566)
@@ -109,5 +109,4 @@
 	&& $rs->count()>1) {
 		$starting_script .= dcPage::jsLoad('js/jquery/jquery-ui.custom.js');
-		$starting_script .= dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js');
 		$starting_script .= dcPage::jsLoad('js/jquery/jquery.mjs.nestedSortable.js');
 }
Index: admin/category.php
===================================================================
--- admin/category.php	(revision 2614)
+++ admin/category.php	(revision 2566)
@@ -176,6 +176,6 @@
 dcPage::open($title,
 	dcPage::jsConfirmClose('category-form').
+	dcPage::jsToolBar().
 	dcPage::jsLoad('js/_category.js'),
-	$core->callBehavior('adminPostEditor').
 	dcPage::breadcrumb($elements)
 );
Index: admin/comment.php
===================================================================
--- admin/comment.php	(revision 2614)
+++ admin/comment.php	(revision 2566)
@@ -181,6 +181,6 @@
 dcPage::open(__('Edit comment'),
 	dcPage::jsConfirmClose('comment-form').
+	dcPage::jsToolBar().
 	dcPage::jsLoad('js/_comment.js').
-	$core->callBehavior('adminPostEditor').
 	# --BEHAVIOR-- adminCommentHeaders
 	$core->callBehavior('adminCommentHeaders'),
Index: admin/index.php
===================================================================
--- admin/index.php	(revision 2614)
+++ admin/index.php	(revision 2566)
@@ -171,6 +171,6 @@
 -------------------------------------------------------- */
 dcPage::open(__('Dashboard'),
+	dcPage::jsToolBar().
 	dcPage::jsLoad('js/_index.js').
-	$core->callBehavior('adminPostEditor').
 	# --BEHAVIOR-- adminDashboardHeaders
 	$core->callBehavior('adminDashboardHeaders'),
Index: admin/js/_category.js
===================================================================
--- admin/js/_category.js	(revision 2614)
+++ admin/js/_category.js	(revision 2566)
@@ -2,7 +2,5 @@
 	dotclear.hideLockable();
 
-	if ($.isFunction('jsToolBar')) {
-		var tbCategory = new jsToolBar(document.getElementById('cat_desc'));
-		tbCategory.draw('xhtml');
-	}
+	var tbCategory = new jsToolBar(document.getElementById('cat_desc'));
+	tbCategory.draw('xhtml');
 });
Index: admin/js/_comment.js
===================================================================
--- admin/js/_comment.js	(revision 2614)
+++ admin/js/_comment.js	(revision 2566)
@@ -1,7 +1,7 @@
 $(function() {
-	if ($.isFunction('jsToolBar')) {
-		var tbComment = new jsToolBar(document.getElementById('comment_content'));
-		tbComment.draw('xhtml');
-	}
+	if (!document.getElementById) { return; }
+
+	var tbComment = new jsToolBar(document.getElementById('comment_content'));
+	tbComment.draw('xhtml');
 
 	$('#comment-form input[name="delete"]').click(function() {
Index: admin/js/_index.js
===================================================================
--- admin/js/_index.js	(revision 2614)
+++ admin/js/_index.js	(revision 1699)
@@ -2,8 +2,6 @@
 	var f = $('#quick-entry');
 	if (f.length > 0) {
-		if ($.isFunction('jsToolBar')) {
-			var contentTb = new jsToolBar($('#post_content',f)[0]);
-			contentTb.switchMode($('#post_format',f).val());
-		}
+		var contentTb = new jsToolBar($('#post_content',f)[0]);
+		contentTb.switchMode($('#post_format',f).val());
 
 		$('input[name=save]',f).click(function() {
@@ -23,5 +21,5 @@
 
 		function quickPost(f,status) {
-			if ($.isFunction('jsToolBar') && (contentTb.getMode() == 'wysiwyg')) {
+			if (contentTb.getMode() == 'wysiwyg') {
 				contentTb.syncContents('iframe');
 			}
@@ -57,5 +55,5 @@
 					$('#post_title',f).val('');
 					$('#post_content',f).val('');
-					if ($.isFunction('jsToolBar') &&  (contentTb.getMode() == 'wysiwyg')) {
+					if (contentTb.getMode() == 'wysiwyg') {
 						contentTb.syncContents('textarea');
 					}
Index: admin/js/_post.js
===================================================================
--- admin/js/_post.js	(revision 2614)
+++ admin/js/_post.js	(revision 2556)
@@ -51,4 +51,36 @@
 
 $(function() {
+	if (!document.getElementById) { return; }
+
+	if (document.getElementById('edit-entry'))
+	{
+		// Get document format and prepare toolbars
+		var formatField = $('#post_format').get(0);
+		var last_post_format = $(formatField).val();
+		$(formatField).change(function() {
+			// Confirm post format change
+			if(window.confirm(dotclear.msg.confirm_change_post_format_noconvert)){
+				excerptTb.switchMode(this.value);
+				contentTb.switchMode(this.value);
+				last_post_format = $(this).val();
+			}else{
+				// Restore last format if change cancelled
+				$(this).val(last_post_format);
+			}
+
+			$('.format_control > *').addClass('hide');
+			$('.format_control:not(.control_no_'+$(this).val()+') > *').removeClass('hide');
+		});
+
+		var excerptTb = new jsToolBar(document.getElementById('post_excerpt'));
+		var contentTb = new jsToolBar(document.getElementById('post_content'));
+		excerptTb.context = contentTb.context = 'post';
+	}
+
+	if (document.getElementById('comment_content')) {
+		var commentTb = new jsToolBar(document.getElementById('comment_content'));
+		commentTb.draw('xhtml');
+	}
+
 	// Post preview
 	$('#post-preview').modalWeb($(window).width()-40,$(window).height()-40);
@@ -67,4 +99,72 @@
 			return window.confirm(dotclear.msg.confirm_delete_post);
 		});
+
+		// Markup validator
+		var v = $('<div class="format_control"><p><a id="a-validator"></a></p><div/>').get(0);
+		$('.format_control').before(v);
+		var a = $('#a-validator').get(0);
+		a.href = '#';
+		a.className = 'button ';
+		$(a).click(function() {
+
+			excerpt_content = $('#post_excerpt').css('display') != 'none' ? $('#post_excerpt').val() : $('#excerpt-area iframe').contents().find('body').html();
+			post_content	= $('#post_content').css('display') != 'none' ? $('#post_content').val() : $('#content-area iframe').contents().find('body').html();
+
+			var params = {
+				xd_check: dotclear.nonce,
+				f: 'validatePostMarkup',
+				excerpt: excerpt_content,
+				content: post_content,
+				format: $('#post_format').get(0).value,
+				lang: $('#post_lang').get(0).value
+			};
+
+			$.post('services.php',params,function(data) {
+				if ($(data).find('rsp').attr('status') != 'ok') {
+					alert($(data).find('rsp message').text());
+					return false;
+				}
+
+				$('.message, .success, .error, .warning-msg').remove();
+
+				if ($(data).find('valid').text() == 1) {
+					var p = document.createElement('p');
+					p.id = 'markup-validator';
+
+					$(p).addClass('success');
+					$(p).text(dotclear.msg.xhtml_valid);
+					$('#entry-content h3').after(p);
+					$(p).backgroundFade({sColor: dotclear.fadeColor.beginValidatorMsg, eColor: dotclear.fadeColor.endValidatorMsg, steps: 50},function() {
+							$(this).backgroundFade({sColor: dotclear.fadeColor.endValidatorMsg, eColor: dotclear.fadeColor.beginValidatorMsg});
+					});
+				} else {
+					var div = document.createElement('div');
+					div.id = 'markup-validator';
+
+					$(div).addClass('error');
+					$(div).html('<p><strong>' + dotclear.msg.xhtml_not_valid + '</strong></p>' + $(data).find('errors').text());
+					$('#entry-content h3').after(div);
+					$(div).backgroundFade({sColor: dotclear.fadeColor.beginValidatorErr,eColor: dotclear.fadeColor.endValidatorErr, steps: 50},function() {
+							$(this).backgroundFade({sColor: dotclear.fadeColor.endValidatorErr, eColor: dotclear.fadeColor.beginValidatorErr});
+					});
+				}
+
+				if ( $('#post_excerpt').text() != excerpt_content || $('#post_content').text() != post_content ) {
+					var pn = document.createElement('p');
+					$(pn).addClass('warning-msg');
+					$(pn).text(dotclear.msg.warning_validate_no_save_content);
+					$('#entry-content h3').after(pn);
+				}
+
+				return false;
+			});
+
+			return false;
+		});
+
+		a.appendChild(document.createTextNode(dotclear.msg.xhtml_validator));
+
+		$('.format_control > *').addClass('hide');
+		$('.format_control:not(.control_no_'+last_post_format+') > *').removeClass('hide');
 
 		// Hide some fields
@@ -117,4 +217,8 @@
 			hide: $('#post_excerpt').val() == ''
 		});
+
+		// Load toolbars
+		contentTb.switchMode(formatField.value);
+		excerptTb.switchMode(formatField.value);
 
 		// Replace attachment remove links by a POST form submit
@@ -129,4 +233,13 @@
 			return false;
 		});
+
+		// Check unsaved changes before XHTML conversion
+		var excerpt = $('#post_excerpt').val();
+		var content = $('#post_content').val();
+		$('#convert-xhtml').click(function() {
+			if (excerpt != $('#post_excerpt').val() || content != $('#post_content').val()) {
+				return window.confirm(dotclear.msg.confirm_change_post_format);
+			}
+		});
 	});
 
Index: admin/js/jsToolBar/jsToolBar.dotclear.js
===================================================================
--- admin/js/jsToolBar/jsToolBar.dotclear.js	(revision 2566)
+++ admin/js/jsToolBar/jsToolBar.dotclear.js	(revision 2566)
@@ -0,0 +1,386 @@
+/* Change link button actions
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.link.data = {};
+jsToolBar.prototype.elements.link.fncall = {};
+jsToolBar.prototype.elements.link.open_url = 'popup_link.php';
+
+jsToolBar.prototype.elements.link.popup = function (args) {
+	window.the_toolbar = this;
+	args = args || '';
+
+	this.elements.link.data = {};
+	var url = this.elements.link.open_url+args;
+
+	var p_win = window.open(url,'dc_popup',
+	'alwaysRaised=yes,dependent=yes,toolbar=yes,height=420,width=520,'+
+	'menubar=no,resizable=yes,scrollbars=yes,status=no');
+};
+
+jsToolBar.prototype.elements.link.fn.wiki = function() {
+	this.elements.link.popup.call(this,'?hreflang='+this.elements.link.default_hreflang);
+};
+jsToolBar.prototype.elements.link.fncall.wiki = function() {
+	var data = this.elements.link.data;
+
+	if (data.href == '') { return; }
+
+	var etag = '|'+data.href;
+	if (data.hreflang) { etag += '|'+data.hreflang; }
+
+	if (data.title) {
+		if (!data.hreflang) { etag += '|'; }
+		etag += '|'+data.title;
+	}
+
+	if (data.content) {
+		this.encloseSelection('['+data.content,etag+']');
+	} else {
+		this.encloseSelection('[',etag+']');
+	}
+};
+
+jsToolBar.prototype.elements.link.fn.xhtml = function() {
+	this.elements.link.popup.call(this,'?hreflang='+this.elements.link.default_hreflang);
+};
+jsToolBar.prototype.elements.link.fncall.xhtml = function() {
+	var data = this.elements.link.data;
+
+	if (data.href == '') { return; }
+
+	var stag = '<a href="'+data.href+'"';
+
+	if (data.hreflang) { stag += ' hreflang="'+data.hreflang+'"'; }
+	if (data.title) { stag += ' title="'+data.title+'"'; }
+	stag += '>';
+	var etag = '</a>';
+
+	if (data.content) {
+		this.encloseSelection('','',function() {
+			return stag + data.content + etag;
+		});
+	} else {
+		this.encloseSelection(stag,etag);
+	}
+};
+
+jsToolBar.prototype.elements.link.fn.wysiwyg = function() {
+	var href, title, hreflang;
+	href = title = hreflang = '';
+	hreflang = this.elements.link.default_hreflang;
+
+	var a = this.getAncestor();
+
+	if (a.tagName == 'a') {
+		href= a.tag.href || '';
+		title = a.tag.title || '';
+		hreflang = a.tag.hreflang || '';
+	}
+
+	this.elements.link.popup.call(this,'?href='+href+'&hreflang='+hreflang+'&title='+title);
+};
+jsToolBar.prototype.elements.link.fncall.wysiwyg = function() {
+	var data = this.elements.link.data;
+
+	var a = this.getAncestor();
+
+	if (a.tagName == 'a') {
+		if (data.href == '') {
+			// Remove link
+			this.replaceNodeByContent(a.tag);
+			this.iwin.focus();
+			return;
+		} else {
+			// Update link
+			a.tag.href = data.href;
+			if (data.hreflang) {
+				a.tag.setAttribute('hreflang',data.hreflang);
+			} else {
+				a.tag.removeAttribute('hreflang');
+			}
+			if (data.title) {
+				a.tag.setAttribute('title',data.title);
+			} else {
+				a.tag.removeAttribute('title');
+			}
+			return;
+		}
+	}
+
+	// Create link
+	if (data.content) {
+		var n = document.createTextNode(data.content);
+	} else {
+		var n = this.getSelectedNode();
+	}
+	var a = this.iwin.document.createElement('a');
+	a.href = data.href;
+	if (data.hreflang) a.setAttribute('hreflang',data.hreflang);
+	if (data.title) a.setAttribute('title',data.title);
+	a.appendChild(n);
+	this.insertNode(a);
+};
+jsToolBar.prototype.getAncestor = function() {
+	var res = {};
+	var range, commonAncestorContainer;
+
+	if (this.iwin.getSelection) { //gecko
+		var selection = this.iwin.getSelection();
+		range = selection.getRangeAt(0);
+		commonAncestorContainer = range.commonAncestorContainer;
+		while (commonAncestorContainer.nodeType != 1) {
+			commonAncestorContainer = commonAncestorContainer.parentNode;
+		}
+	} else { //ie
+		range = this.iwin.document.selection.createRange();
+		commonAncestorContainer = range.parentElement();
+	}
+
+	var ancestorTagName = commonAncestorContainer.tagName.toLowerCase();
+	while (ancestorTagName!='a' && ancestorTagName!='body') {
+		commonAncestorContainer = commonAncestorContainer.parentNode;
+		ancestorTagName = commonAncestorContainer.tagName.toLowerCase();
+	}
+
+	res.tag = commonAncestorContainer;
+	res.tagName = ancestorTagName;
+
+	return res;
+};
+
+/* Image selector
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.img_select = {
+	type: 'button',
+	title: 'Image chooser',
+	fn: {},
+	fncall: {},
+	open_url: 'media.php?popup=1',
+	data: {},
+	popup: function() {
+		window.the_toolbar = this;
+		this.elements.img_select.data = {};
+
+		var p_win = window.open(this.elements.img_select.open_url,'dc_popup',
+		'alwaysRaised=yes,dependent=yes,toolbar=yes,height=500,width=760,'+
+		'menubar=no,resizable=yes,scrollbars=yes,status=no');
+	}
+};
+jsToolBar.prototype.elements.img_select.fn.wiki = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.wiki = function() {
+	var d = this.elements.img_select.data;
+	if (d.src == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		var alt = (str) ? str : d.title;
+		var res = '(('+d.src+'|'+alt;
+
+		if (d.alignment == 'left') {
+			res += '|L';
+		} else if (d.alignment == 'right') {
+			res += '|R';
+		} else if (d.alignment == 'center') {
+			res += '|C';
+		} else if (d.description) {
+			res += '|';
+		}
+
+		if (d.description) {
+			res += '|'+d.description;
+		}
+
+		res += '))';
+
+		if (d.link) {
+			var ltitle = (alt) ? '||'+alt : '';
+			res = '['+res+'|'+d.url+ltitle+']';
+		}
+
+		return res;
+	});
+};
+jsToolBar.prototype.elements.img_select.fn.xhtml = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.xhtml = function() {
+	var d = this.elements.img_select.data;
+	if (d.src == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		var alt = (str) ? str : d.title;
+		var res = '<img src="'+d.src+'" alt="'+alt.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"';
+
+		if (d.alignment == 'left') {
+			res += ' style="float: left; margin: 0 1em 1em 0;"';
+		} else if (d.alignment == 'right') {
+			res += ' style="float: right; margin: 0 0 1em 1em;"';
+		} else if (d.alignment == 'center') {
+			res += ' style="margin: 0 auto; display: block;"';
+		}
+
+		if (d.description) {
+			res += ' title="'+d.description.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"';
+		}
+
+		res += ' />';
+
+		if (d.link) {
+			var ltitle = (alt) ? ' title="'+alt.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"' : '';
+			res = '<a href="'+d.url+'"'+ltitle+'>'+res+'</a>';
+		}
+
+		return res;
+	});
+};
+
+jsToolBar.prototype.elements.img.fn.wysiwyg = function() {
+	var src = this.elements.img.prompt.call(this);
+	if (!src) { return; }
+
+	var img = this.iwin.document.createElement('img');
+	img.src = src;
+	img.setAttribute('alt',this.getSelectedText());
+
+	this.insertNode(img);
+};
+
+jsToolBar.prototype.elements.img_select.fn.wysiwyg = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.wysiwyg = function() {
+	var d = this.elements.img_select.data;
+	var alt = (this.getSelectedText()) ? this.getSelectedText() : d.title;
+	if (d.src == undefined) { return; }
+
+	var img = this.iwin.document.createElement('img');
+	img.src = d.src;
+	img.setAttribute('alt',alt);
+
+
+	if (d.alignment == 'left') {
+		if (img.style.styleFloat != undefined) {
+			img.style.styleFloat = 'left';
+		} else {
+			img.style.cssFloat = 'left';
+		}
+		img.style.marginTop = 0;
+		img.style.marginRight = '1em';
+		img.style.marginBottom = '1em';
+		img.style.marginLeft = 0;
+	} else if (d.alignment == 'right') {
+		if (img.style.styleFloat != undefined) {
+			img.style.styleFloat = 'right';
+		} else {
+			img.style.cssFloat = 'right';
+		}
+		img.style.marginTop = 0;
+		img.style.marginRight = 0;
+		img.style.marginBottom = '1em';
+		img.style.marginLeft = '1em';
+	} else if (d.alignment == 'center') {
+		img.style.marginTop = 0;
+		img.style.marginRight = 'auto';
+		img.style.marginBottom = 0;
+		img.style.marginLeft = 'auto';
+		img.style.display = 'block';
+	}
+
+	if (d.description) {
+		img.setAttribute('title',d.description);
+	}
+
+	if (d.link) {
+		var a = this.iwin.document.createElement('a');
+		a.href = d.url;
+		if (alt) {
+			a.setAttribute('title',alt);
+		}
+		a.appendChild(img);
+		this.insertNode(a);
+	} else {
+		this.insertNode(img);
+	}
+};
+
+// MP3 helpers
+jsToolBar.prototype.elements.mp3_insert = { fncall: {}, data: {} };
+jsToolBar.prototype.elements.mp3_insert.fncall.wiki = function() {
+	var d = this.elements.mp3_insert.data;
+	if (d.player == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		return '\n///html\n' + d.player + '///\n';
+	});
+};
+jsToolBar.prototype.elements.mp3_insert.fncall.xhtml = function() {
+	var d = this.elements.mp3_insert.data;
+	if (d.player == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		return '\n' + d.player + '\n';
+	});
+};
+jsToolBar.prototype.elements.mp3_insert.fncall.wysiwyg = function() {
+	return;
+};
+
+// FLV helpers
+jsToolBar.prototype.elements.flv_insert = { fncall: {}, data: {} };
+jsToolBar.prototype.elements.flv_insert.fncall.wiki = function() {
+	var d = this.elements.flv_insert.data;
+	if (d.player == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		return '\n///html\n' + d.player + '///\n';
+	});
+};
+jsToolBar.prototype.elements.flv_insert.fncall.xhtml = function() {
+	var d = this.elements.flv_insert.data;
+	if (d.player == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		return '\n' + d.player + '\n';
+	});
+};
+jsToolBar.prototype.elements.flv_insert.fncall.wysiwyg = function() {
+	return;
+};
+
+
+/* Posts selector
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.post_link = {
+	type: 'button',
+	title: 'Link to an entry',
+	fn: {},
+	open_url: 'popup_posts.php',
+	data: {},
+	popup: function() {
+		window.the_toolbar = this;
+		this.elements.img_select.data = {};
+
+		var p_win = window.open(this.elements.post_link.open_url,'dc_popup',
+		'alwaysRaised=yes,dependent=yes,toolbar=yes,height=500,width=760,'+
+		'menubar=no,resizable=yes,scrollbars=yes,status=no');
+	}
+};
+jsToolBar.prototype.elements.post_link.fn.wiki = function() {
+	this.elements.post_link.popup.call(this);
+};
+jsToolBar.prototype.elements.post_link.fn.xhtml = function() {
+	this.elements.post_link.popup.call(this);
+};
+jsToolBar.prototype.elements.post_link.fn.wysiwyg = function() {
+	this.elements.post_link.popup.call(this);
+};
+
+// Last space element
+jsToolBar.prototype.elements.space3 = {
+	type:'space',
+	format:{
+		wysiwyg:true,
+		wiki:true,
+		xhtml:true
+	}
+};
